package net.minecraft.src;

import java.util.HashMap;
import java.util.Map;

// SDK Grappling Hook
@SuppressWarnings({ "rawtypes", "unchecked" })
public class mod_SdkGrapplingHook extends SdkBaseModMp
{
    public static Block blockRope;
    public static Block blockGrapplingHook;
    
    public static final Item itemRope = (new Item(2511)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemRope.png")).setItemName("itemRope");
    public static final Item itemGrapplingHook = (new SdkItemGrapplingHook(2512)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrapplingHook.png")).setItemName("itemGrapplingHook");
    
	// Instead of in EntityPlayer
    public static Map<EntityPlayer, SdkEntityGrapplingHook> grapplingHooks = new HashMap<EntityPlayer, SdkEntityGrapplingHook>();
	
	public mod_SdkGrapplingHook()
    {
		super();
    	
		ModLoader.RegisterEntityID(SdkEntityGrapplingHook.class, "GrapplingHook", ModLoader.getUniqueEntityId());
		
		ModLoader.RegisterTileEntity(SdkTileEntityRope.class, "Rope");
		
		ModLoaderMp.RegisterEntityTracker(SdkEntityGrapplingHook.class, 64, 5);
		
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityGrapplingHook.class, 133);
    }
    
	@Override
    public void InitBlocks()
    {
    	blockRope = (new SdkBlockRope(115, ModLoader.addOverride("/terrain.png", "/sdk/blockRope.png"), ModLoader.getUniqueBlockModelID(this, false))).setHardness(-1F).setResistance(6000000F).setStepSound(Block.soundClothFootstep).setBlockName("blockRope");
        blockGrapplingHook = (new SdkBlockGrapplingHook(116, ModLoader.addOverride("/terrain.png", "/sdk/blockGrapplingHook.png"), ModLoader.getUniqueBlockModelID(this, false))).setHardness(0.0F).setStepSound(Block.soundMetalFootstep).setBlockName("blockGrapplingHook");
		
    	ModLoader.RegisterBlock(blockRope);
    	ModLoader.RegisterBlock(blockGrapplingHook);
    }

	@Override
	public String Version()
	{
		return "1.4_01v3";
	}

	@Override
    public void SetRecipes()
    {
		SdkTools.setShapedRecipe(true, new ItemStack(itemGrapplingHook, 1), new Object[] {
        	"X", "#", "#", Character.valueOf('#'), itemRope, Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(true, new ItemStack(itemRope, 1), new Object[] {
            "##", "##", "##", Character.valueOf('#'), Item.silk
        });
    }

	@Override
	public void OnMainMenu() { }
}
