package net.minecraft.src;

import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.net.URISyntaxException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import net.minecraft.server.MinecraftServer;

// TODO If you change block IDs, you can't play multiplayer
// TODO Plaques don't show item held
// TODO Heap space error on Packet200ModLoader on server, only happens to server owner???
// TODO Grappling hook doesn't show in air

// TODO First nade doesn't reduce count, nades don't have this problem actually, was happening with sentries though
// TODO No sound picking up casings
// TODO Flame starts sideways/backwards, fix with a small initial velocity?
// TODO Handle recoil spread

// TODO Scoring
// TODO Minimap with teammates on it
// TODO Respawn with weapon, set ID
// TODO Have option that mouse wheel scroll doesn't go to empty space?
// TODO Nether spawn locations

// SDK Guns
@SuppressWarnings({ "rawtypes", "unchecked" })
public class mod_SdkGuns extends SdkBaseModMp
{
    public static Block blockNuke;
    public static Block blockSentry;
    public static Block blockLighter;
    public static int blockLighterSideIndexInTexture;
    public static Block blockOil;
    public static int blockOilLineIndexInTexture;
    public static Block blockCannon;
    
	public static final Item itemBulletCasing = new Item(2500).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasing.png")).setItemName("bulletCasing");
    public static final Item itemBulletLight = new Item(2501).setMaxStackSize(32).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet9mm.png")).setItemName("bullet9mm");
    public static final Item itemBulletMedium = new Item(2502).setMaxStackSize(8).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet357.png")).setItemName("bullet357");
    public static final Item itemBulletShell = new Item(2503).setMaxStackSize(8).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletShell.png")).setItemName("bulletShell");
    public static final Item itemGunAk47 = new SdkItemGunAk47(2504).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunAk47.png")).setItemName("gunAk47");
    public static final Item itemGunMp5 = new SdkItemGunMp5(2505).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunMp5.png")).setItemName("gunMp5");
    public static final Item itemGunShotgun = new SdkItemGunShotgun(2506).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunShotgun.png")).setItemName("gunShotgun");
    public static final Item itemGunDeagle = new SdkItemGunDeagle(2507).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunDeagle.png")).setItemName("gunDeagle");
    public static final Item itemGrenade = new SdkItemGrenade(2508).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenade.png")).setItemName("grenade");
    public static final Item itemMetalParts = new Item(2514).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemMetalParts.png")).setItemName("metalParts");
    public static final Item itemBulletRocket = new Item(2515).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocket.png")).setItemName("bulletRocket");
    public static final Item itemGunRocketLauncher = new SdkItemGunRocketLauncher(2516).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncher.png")).setItemName("gunRocketLauncher");
    public static final Item itemBulletRocketLaser = new Item(2517).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocketLaser.png")).setItemName("bulletRocketLaser");
    public static final Item itemGunRocketLauncherLaser = new SdkItemGunRocketLauncherLaser(2518).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncherLaser.png")).setItemName("gunRocketLauncherLaser");
    public static final Item itemBulletHeavy = new Item(2519).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet50Cal.png")).setItemName("bullet50Cal");
    public static final Item itemGunSniper = new SdkItemGunSniper(2520).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSniper.png")).setItemName("gunSniper");
    public static final Item itemGrenadeStun = new SdkItemGrenadeStun(2522).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeStun.png")).setItemName("grenadeStun");
    public static final Item itemGrenadeSmoke = new SdkItemGrenadeSmoke(2524).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSmoke.png")).setItemName("grenadeSmoke");
    public static final Item itemBulletCasingShell = new Item(2525).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasingShell.png")).setItemName("bulletCasingShell");
    public static final Item itemOil = new SdkItemOil(2526).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemOil.png")).setItemName("itemOil");
    public static final Item itemGunFlamethrower = new SdkItemGunFlamethrower(2527).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunFlamethrower.png")).setItemName("gunFlamethrower");
    public static final Item itemGrenadeSticky = new SdkItemGrenadeSticky(2530).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSticky.png")).setItemName("grenadeSticky");
    public static final Item itemGunSg552 = new SdkItemGunSg552(2531).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSg552.png")).setItemName("gunSg552");
    public static final Item itemGunMinigun = new SdkItemGunMinigun(2532).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunMinigun.png")).setItemName("gunMinigun");
    public static final Item itemGunLaser = new SdkItemGunLaser(2535).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunLaser.png")).setItemName("gunLaser");
    public static final Item itemGunM4 = new SdkItemGunM4(2536).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunM4.png")).setItemName("gunM4");
    public static final Item itemGrenadeIncendiary = new SdkItemGrenadeIncendiary(2537).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeIncendiary.png")).setItemName("grenadeIncendiary");
    public static final Item itemGrenadeIncendiaryLit = new SdkItemGrenadeIncendiary(2554).setMaxStackSize(4).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeIncendiaryLit.png")).setItemName("grenadeIncendiaryLit");

    public static final Item itemBarrelLong = new Item(2538).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelLong.png")).setItemName("itemBarrelLong");
    public static final Item itemBarrelShort = new Item(2539).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelShort.png")).setItemName("itemBarrelShort");
    public static final Item itemBarrelFat = new Item(2540).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelFat.png")).setItemName("itemBarrelFat");
    public static final Item itemBarrelShotgun = new Item(2541).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelShotgun.png")).setItemName("itemBarrelShotgun");
    public static final Item itemBarrelMinigun = new Item(2542).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBarrelMinigun.png")).setItemName("itemBarrelMinigun");
    public static final Item itemGripWood = new Item(2543).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGripWood.png")).setItemName("itemGripWood");
    public static final Item itemGripMetal = new Item(2544).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGripMetal.png")).setItemName("itemGripMetal");
    public static final Item itemHandleMinigun = new Item(2545).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemHandleMinigun.png")).setItemName("itemHandleMinigun");
    public static final Item itemStockWood = new Item(2546).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemStockWood.png")).setItemName("itemStockWood");
    public static final Item itemStockMetal = new Item(2547).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemStockMetal.png")).setItemName("itemStockMetal");
    public static final Item itemReceiverMetal = new Item(2548).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemReceiverMetal.png")).setItemName("itemReceiverMetal");
    public static final Item itemReceiverDiamond = new Item(2549).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemReceiverDiamond.png")).setItemName("itemReceiverDiamond");
    public static final Item itemMagazine = new Item(2550).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemMagazine.png")).setItemName("itemMagazine");
    public static final Item itemScope = new Item(2551).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemScope.png")).setItemName("itemScope");

    public static final Item itemAtv = new SdkItemAtv(2552).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemAtv.png")).setItemName("itemAtv");
    public static final Item itemAtvBody = new Item(2553).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemAtvBody.png")).setItemName("itemAtvBody");
    public static Item itemAtvWheel;
    public static boolean hasPlanesMod = false;
    public static final Item itemWrench = new Item(2555).setMaxStackSize(1).setMaxDamage(15).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemWrench.png")).setItemName("itemWrench");
    
    public static final Item itemSentry = new SdkItemSentry(2556).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/blockSentry.png")).setMaxStackSize(1).setMaxDamage(0).setHasSubtypes(true).setItemName("itemSentry");

    // Sentry classes and textures
    public static Class[] sentryEntityClasses = { SdkEntitySentryAk47.class, SdkEntitySentryMp5.class, SdkEntitySentryShotgun.class,
    	SdkEntitySentryDeagle.class, SdkEntitySentryRocketLauncher.class, SdkEntitySentryRocketLauncherLaser.class, SdkEntitySentrySniper.class,
    	SdkEntitySentryFlamethrower.class, SdkEntitySentrySg552.class, SdkEntitySentryMinigun.class, SdkEntitySentryLaser.class,
    	SdkEntitySentryM4.class };
    
    // Reload
    public static Map<EntityPlayer, Integer> reloadTimes = new HashMap<EntityPlayer, Integer>();
    
    // Recoil
    public static final double RECOIL_FIX_FACTOR = 0.1F;
    public static double currentRecoilV = 0F;
    public static double currentRecoilH = 0F;

    // Zoom
	private static Map<EntityPlayer, Boolean> isSniperZoomedin = new HashMap<EntityPlayer, Boolean>();

	// Flash
    public static Map<EntityLiving, Pair<Integer, Float>> flashTimes = new HashMap<EntityLiving, Pair<Integer, Float>>();
    
    // Properties
    public static boolean guns = true;
    public static boolean bulletsDestroyGlass = true;
    public static boolean grenades = true;
    public static boolean explosionsDestroyBlocks = true;
    public static boolean laserSetsFireToBlocks = true;
    public static boolean nuke = true;
    public static float nukeBlastDiameter = 8;
    public static int nukeFuse = 80;
    public static boolean oil = true;
    public static boolean lighter = true;
    public static boolean cannon = true;
    public static boolean sentries = true;
    public static boolean sentriesKillAnimals = false;
    public static boolean atv = false;
    public static boolean ammoRestrictions = true;
    public static boolean hardcore = false;
    public static boolean ammoCasings = true;

	// For burst fire
	public static Map<Entity, SdkBurstShotEntry> burstShots = new HashMap<Entity, SdkBurstShotEntry>();

    static
    {
    	loadProperties();
    }
    
    private static void loadProperties()
    {
    	Properties properties = new Properties();
    	try
    	{
    		String propertiesPath = mod_SdkGuns.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath();
    		propertiesPath = propertiesPath.substring(0, propertiesPath.lastIndexOf('/'));
    		propertiesPath += "/mod_SdkGuns.properties";
    		
    		try
        	{
	    		properties.load(new FileInputStream(propertiesPath));
	        }
	        catch (Exception ex)
	        {
				ModLoader.getLogger().throwing("mod_SdkGuns", "loadProperties", ex);
				ModLoader.ThrowException("mod_SdkGuns.properties not found in the server folder.", ex);
				return;
	        }
        
    		String property;
    		
    		property = properties.getProperty("guns");
    		guns = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("bulletsDestroyGlass");
    		bulletsDestroyGlass = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("grenades");
    		grenades = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("explosionsDestroyBlocks");
    		explosionsDestroyBlocks = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("laserSetsFireToBlocks");
    		laserSetsFireToBlocks = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("nuke");
    		nuke = property.trim().equalsIgnoreCase("true");

    		property = properties.getProperty("nukeBlastDiameter");
    		nukeBlastDiameter = Float.parseFloat(property.trim());

    		property = properties.getProperty("nukeFuse");
    		nukeFuse = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("oil");
    		oil = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("lighter");
    		lighter = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("cannon");
    		cannon = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentries");
    		sentries = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentriesKillAnimals");
    		sentriesKillAnimals = property.trim().equalsIgnoreCase("true");
    		
    		/*property = properties.getProperty("atv");
    		atv = property.trim().equalsIgnoreCase("true");*/
    		
    		property = properties.getProperty("ammoRestrictions");
    		ammoRestrictions = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("hardcore");
    		hardcore = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoCasings");
    		ammoCasings = property.trim().equalsIgnoreCase("true");
        }
    	catch (URISyntaxException ex)
    	{
    		ModLoader.getLogger().throwing("mod_SdkGuns", "loadProperties", ex);
			SdkTools.ThrowException("An impossible error has occurred!", ex);
			return;
    	}
    	catch (Exception ex)
    	{
    		if(ex instanceof RuntimeException)
    			throw (RuntimeException)ex;
    		else
    		{
	    		ModLoader.getLogger().throwing("mod_SdkGuns", "loadProperties", ex);
				SdkTools.ThrowException("mod_SdkGuns.properties is corrupt.", ex);
				return;
    		}
    	}
    }
	
	public mod_SdkGuns()
	{
		super();
		
		setHardcore();
	    
	    // For showing ammo amount
	    itemBulletLight.setMaxDamage(0);
	    itemBulletMedium.setMaxDamage(0);
	    itemBulletShell.setMaxDamage(0);
	    itemBulletRocket.setMaxDamage(0);
	    itemBulletRocketLaser.setMaxDamage(0);
	    itemBulletHeavy.setMaxDamage(0);
	    Item.redstone.setMaxDamage(0);
		
		ModLoader.RegisterEntityID(SdkEntityBulletShot.class, "Shell", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasing.class, "Casing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasingShell.class, "ShellCasing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenade.class, "Grenade", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityNukePrimed.class, "Nuke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryAk47.class, "SentryAk47", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryDeagle.class, "SentryDeagle", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryMp5.class, "SentryMp5", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncher.class, "SentryRocketLauncher", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncherLaser.class, "SentryRocketLauncherLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryShotgun.class, "SentryShotgun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySniper.class, "SentrySniper", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocket.class, "Rocket", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocketLaser.class, "RocketLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeStun.class, "GrenadeStun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSmoke.class, "GrenadeSmoke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletFlame.class, "Flame", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryFlamethrower.class, "SentryFlamethrower", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSticky.class, "GrenadeSticky", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySg552.class, "SentrySg552", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletLaser.class, "Laser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryMinigun.class, "SentryMinigun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryLaser.class, "SentryLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeIncendiary.class, "GrenadeIncendiary", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryM4.class, "SentryM4", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityAtv.class, "ATV", ModLoader.getUniqueEntityId());
		
		ModLoaderMp.RegisterEntityTracker(SdkEntityBullet.class, 64, 5);
		ModLoaderMp.RegisterEntityTracker(SdkEntityBulletCasing.class, 64, 5);
		ModLoaderMp.RegisterEntityTracker(SdkEntityNukePrimed.class, 160, 10);
		ModLoaderMp.RegisterEntityTracker(SdkEntitySentry.class, 160, 3);
		ModLoaderMp.RegisterEntityTracker(SdkEntityAtv.class, 160, 5);
		
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletAk47.class, 100);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletCasing.class, 101);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletCasingShell.class, 102);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletDeagle.class, 103);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletFlame.class, 104);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletLaser.class, 105);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletM4.class, 106);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletMinigun.class, 107);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletMp5.class, 108);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletRocket.class, 109);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletRocketLaser.class, 110);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletSg552.class, 111);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletShot.class, 112);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityBulletSniper.class, 113);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityGrenade.class, 114);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityGrenadeIncendiary.class, 115);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityGrenadeSmoke.class, 116);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityGrenadeSticky.class, 117);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityGrenadeStun.class, 118);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityNukePrimed.class, 119);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryAk47.class, 120);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryDeagle.class, 121);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryFlamethrower.class, 122);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryLaser.class, 123);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryMinigun.class, 124);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryM4.class, 125);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryMp5.class, 126);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryRocketLauncher.class, 127);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryRocketLauncherLaser.class, 128);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentrySg552.class, 129);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentryShotgun.class, 130);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntitySentrySniper.class, 131);
		ModLoaderMp.RegisterEntityTrackerEntry(SdkEntityAtv.class, 134);
	}
    
	@Override
    public void InitBlocks()
    {
    	blockNuke = (new SdkBlockNuke(110, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"))).setHardness(0.0F).setStepSound(Block.soundGrassFootstep).setBlockName("nuke");
        blockSentry = (new SdkBlockSentry(111, ModLoader.addOverride("/terrain.png", "/sdk/blockSentry.png"))).setBlockName("sentry");
        blockLighter = (new SdkBlockLighter(112, ModLoader.addOverride("/terrain.png", "/sdk/blockLighterTop.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("lighter");
        blockLighterSideIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockLighterSide.png");
        blockOil = (new SdkBlockOil(113, ModLoader.addOverride("/terrain.png", "/sdk/blockOilJunction.png"), ModLoader.getUniqueBlockModelID(this, false))).setHardness(-1F).setBlockName("blockOil");
        blockOilLineIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockOilLine.png");
        blockCannon = (new SdkBlockCannon(114, ModLoader.addOverride("/terrain.png", "/sdk/blockCannon.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("cannon");
        
		ModLoader.RegisterBlock(blockNuke);
		ModLoader.RegisterBlock(blockSentry);
		ModLoader.RegisterBlock(blockLighter);
		ModLoader.RegisterBlock(blockOil);
		ModLoader.RegisterBlock(blockCannon);

		setBurnRates();
        
        try
        {
        	Class planes;
			try
			{
				planes = Class.forName("mod_Planes");
			}
    		catch (ClassNotFoundException ex)
    		{
    			planes = Class.forName("net.minecraft.src.mod_Planes");
    		}
    		
	        Field planesWheel = planes.getDeclaredField("wheel");
	        itemAtvWheel = (Item)planesWheel.get(null);
	        hasPlanesMod = true;
        }
        catch (Exception ex) {
        	System.out.println("mod_Planes not found in mod_SdkGuns. Ignore this exception if you do not have it installed.");
        	itemAtvWheel = new Item(23004).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemAtvWheel.png")).setItemName("itemAtvWheel");
        }
    }

	public static void setBurnRates()
	{
		//SdkTools.setBurnRate(blockNuke.blockID, 15, 100);
		SdkTools.setBurnRate(blockOil.blockID, 30, 60);
	}
	
	@Override
	public String Version()
	{
		return "1.4_01v3";
	}
	
	@Override
	public void OnTickInGameTick(MinecraftServer minecraftServer)
	{
		// Handle reload
		handleReload();
		
		// Handle flash
		handleFlash();
	}

	private void setHardcore()
    {
    	try
		{
    		Field[] fields = EnumCreatureType.class.getDeclaredFields();
			for(int i = 0; i < fields.length; i++)
				if(fields[i].getType() == int.class)
				{
					fields[i].setAccessible(true);
					
					Field modifiersField = Field.class.getDeclaredField("modifiers");
				    modifiersField.setAccessible(true);
				    modifiersField.setInt(fields[i], fields[i].getModifiers() & ~Modifier.FINAL);
					
				    int numMobs, numCreatures, numWaterCreatures;
				    if(hardcore)
				    {
				    	numMobs = 700;
				    	numCreatures = 15;
				    	numWaterCreatures = 50;
				    }
				    else
				    {
				    	numMobs = 70;
				    	numCreatures = 15;
				    	numWaterCreatures = 5;
				    }
				    
				    Calendar calendar = Calendar.getInstance();
				    if(calendar.get(Calendar.MONTH) == Calendar.APRIL && calendar.get(Calendar.DAY_OF_MONTH) == 1)
				    	numCreatures = 200;
				    
				    fields[i].set(EnumCreatureType.monster, numMobs);
				    fields[i].set(EnumCreatureType.creature, numCreatures);
				    fields[i].set(EnumCreatureType.waterCreature, numWaterCreatures);
				}
		}
		catch (Exception ex)
		{
			ModLoader.getLogger().throwing("mod_SdkGuns", "setHardcore", ex);
			SdkTools.ThrowException("SDK, you forgot to update your obfuscated reflection!", ex);
			return;
		}
    }

	@Override
	public void SetRecipes() {
    	itemBulletLight.maxStackSize = 32;
    	itemBulletMedium.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemBulletShell.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemGrenade.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemBulletRocket.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletRocketLaser.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletHeavy.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemGrenadeStun.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSmoke.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSticky.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeIncendiary.maxStackSize = ammoRestrictions ? 4 : 64;
		
		SdkTools.setShapedRecipe(nuke, new ItemStack(blockNuke, 1), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Block.tnt, Character.valueOf('#'), Item.redstone
        });
		
		/*SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunAk47, 1), new Object[] {
            "X  ", "XX ", " X#", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunMp5, 1), new Object[] {
        	"X  ", "XX ", " XX", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunDeagle, 1), new Object[] {
        	"XXX", "  X", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunShotgun, 1), new Object[] {
        	"X  ", "#X ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncher, 1), new Object[] {
            "XXX", "XX ", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncherLaser, 1), new Object[] {
            "#XY", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), itemMetalParts, Character.valueOf('Y'), itemGunRocketLauncher
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSniper, 1), new Object[] {
            "X  ", " X#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunFlamethrower, 1), new Object[] {
			"X# ", "XX ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.flintAndSteel
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSg552, 1), new Object[] {
			"X  ", "XX#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunMinigun, 1), new Object[] {
			"XX ", "XXX", " XX", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunLaser, 1), new Object[] {
        	"#  ", "XX ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunM4, 1), new Object[] {
        	"X", Character.valueOf('X'), itemMetalParts
        });*/
		SdkTools.setShapedRecipe(guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasing
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletLight, ammoRestrictions ? 4 : itemBulletLight.maxStackSize), new Object[] {
            "X", "#", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletMedium, ammoRestrictions ? 4 : itemBulletMedium.maxStackSize), new Object[] {
            "X ", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletShell, ammoRestrictions ? 4 : itemBulletShell.maxStackSize), new Object[] {
            "X ", "#Y", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder, Character.valueOf('Y'), Item.paper
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletRocket, ammoRestrictions ? 1 : itemBulletRocket.maxStackSize), new Object[] {
            "###", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletRocketLaser, ammoRestrictions ? 1 : itemBulletRocketLaser.maxStackSize), new Object[] {
            "#Y#", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron,  Character.valueOf('Y'), Item.redstone
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBulletHeavy, itemBulletHeavy.maxStackSize), new Object[] {
            "XX", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasingShell
        });
		
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBarrelLong), new Object[] {
        	"XXX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBarrelShort), new Object[] {
        	"XX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemBarrelFat), new Object[] {
        	"XXX", "XXX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemBarrelShotgun), new Object[] {
			new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong)
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemBarrelMinigun), new Object[] {
			new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong),
			new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong), new ItemStack(itemBarrelLong)
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGripWood), new Object[] {
        	"XX", " X", " X", Character.valueOf('X'), Block.wood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGripMetal), new Object[] {
        	"XX", " X", " X", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemHandleMinigun), new Object[] {
        	"XX", " X", "XX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemStockWood), new Object[] {
        	"XXX", " XX", Character.valueOf('X'), Block.wood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemStockMetal), new Object[] {
        	"XXX", " XX", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemReceiverMetal), new Object[] {
        	Item.ingotIron, Item.ingotIron, itemMetalParts
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemReceiverDiamond), new Object[] {
        	"XX", "XX", Character.valueOf('X'), Item.diamond
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemMagazine), new Object[] {
        	"X", "X", Character.valueOf('X'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemScope), new Object[] {
        	"X#X", Character.valueOf('X'), Item.diamond, Character.valueOf('#'), Item.ingotIron
        });
		
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunAk47), new Object[] {
            "ABC", "DE ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockWood, 'D', itemMagazine, 'E', itemGripWood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunMp5), new Object[] {
            "ABC", "DE ", 'A', itemBarrelShort, 'B', itemReceiverMetal, 'C', itemStockMetal, 'D', itemMagazine, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunM4), new Object[] {
            "ABC", "DE ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockMetal, 'D', itemMagazine, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunFlamethrower), new Object[] {
            "AB", "DE", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'D', Item.bucketEmpty, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunSg552), new Object[] {
            " F ", "ABC", "DE ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockMetal, 'D', itemMagazine, 'E', itemGripMetal, 'F', itemScope
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunSniper), new Object[] {
            " F ", "ABC", " E ", 'A', itemBarrelLong, 'B', itemReceiverMetal, 'C', itemStockMetal, 'E', itemGripMetal, 'F', itemScope
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunLaser), new Object[] {
            "ABC", " E ", 'A', itemBarrelShort, 'B', itemReceiverDiamond, 'C', itemStockMetal, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunDeagle), new Object[] {
            "AB", " E", 'A', itemBarrelShort, 'B', itemReceiverMetal, 'E', itemGripMetal
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunShotgun), new Object[] {
            "ABC", " E ", 'A', itemBarrelShotgun, 'B', itemReceiverMetal, 'C', itemStockWood, 'E', itemGripWood
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunRocketLauncher), new Object[] {
            "AAA", "BB ", 'A', itemBarrelFat, 'B', itemGripMetal
        });
		SdkTools.setShapelessRecipe(guns, new ItemStack(itemGunRocketLauncherLaser), new Object[] {
			new ItemStack(Item.diamond), new ItemStack(itemMetalParts), new ItemStack(itemGunRocketLauncher)
        });
		SdkTools.setShapedRecipe(guns, new ItemStack(itemGunMinigun), new Object[] {
			" F ", "ABC", 'A', itemBarrelMinigun, 'B', itemReceiverMetal, 'C', itemStockMetal, 'F', itemHandleMinigun
        });
		
		SdkTools.setShapedRecipe(guns || sentries, new ItemStack(itemMetalParts, 1), new Object[] {
			"##", "##", Character.valueOf('#'), Item.ingotIron
		});
		SdkTools.setShapedRecipe(guns || sentries, new ItemStack(Item.ingotIron, 4), new Object[] {
			"#", Character.valueOf('#'), itemMetalParts
		});
		
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenade, 4), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenadeStun, 4), new Object[] {
            "X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.lightStoneDust
        });
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenadeSmoke, 4), new Object[] {
			"X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.flint
        });
		SdkTools.setShapelessRecipe(grenades, new ItemStack(itemGrenadeSticky), new Object[] {
            new ItemStack(itemGrenade), new ItemStack(Item.slimeBall)
        });
		SdkTools.setShapedRecipe(grenades, new ItemStack(itemGrenadeIncendiary, 4), new Object[] {
			" X ", "#Y#", " # ", Character.valueOf('X'), Item.paper, Character.valueOf('#'), Block.glass, Character.valueOf('Y'), itemOil
        });
		
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 0), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunAk47, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 1), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunMp5, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 2), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunShotgun, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 3), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunDeagle, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 4), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncher, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 5), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncherLaser, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 6), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSniper, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 7), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunFlamethrower, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 8), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSg552, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 9), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunMinigun, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 10), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunLaser, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(sentries && guns, new ItemStack(itemSentry, 1, 11), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunM4, Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(sentries && !guns, new ItemStack(itemSentry, 1, 0), new Object[] {
        	" X ", " X ", "X X", Character.valueOf('X'), itemMetalParts
        });
		
		// To allow conversion from blocks to items
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 0), new Object[] {
            new ItemStack(blockSentry, 1, 0)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 1), new Object[] {
            new ItemStack(blockSentry, 1, 1)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 2), new Object[] {
            new ItemStack(blockSentry, 1, 2)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 3), new Object[] {
            new ItemStack(blockSentry, 1, 3)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 4), new Object[] {
            new ItemStack(blockSentry, 1, 4)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 5), new Object[] {
            new ItemStack(blockSentry, 1, 5)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 6), new Object[] {
            new ItemStack(blockSentry, 1, 6)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 7), new Object[] {
            new ItemStack(blockSentry, 1, 7)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 8), new Object[] {
            new ItemStack(blockSentry, 1, 8)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 9), new Object[] {
            new ItemStack(blockSentry, 1, 9)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 10), new Object[] {
            new ItemStack(blockSentry, 1, 10)
        });
		SdkTools.setShapelessRecipe(true, new ItemStack(itemSentry, 1, 11), new Object[] {
            new ItemStack(blockSentry, 1, 11)
        });
		
		SdkTools.setShapedRecipe(lighter, new ItemStack(blockLighter, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Block.cobblestone, Character.valueOf('#'), Item.flintAndSteel
        });
	
		SdkTools.setShapedRecipe(oil, new ItemStack(itemOil, 1), new Object[] {
        	" X ", "X#X", " X ", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.bucketWater
        });
		
		SdkTools.setShapedRecipe(cannon, new ItemStack(blockCannon, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.redstone
        });

		SdkTools.setShapedRecipe(atv, new ItemStack(itemAtvBody), new Object[] {
        	"ZXZ", "XYX", "ZXZ", 'X', Item.ingotIron, 'Y', Block.stoneOvenIdle, 'Z', Item.redstone
        });
		SdkTools.setShapedRecipe(atv, new ItemStack(itemAtv), new Object[] {
        	" X ", "XYX", " X ", 'X', itemAtvWheel, 'Y', itemAtvBody
        });
		SdkTools.setShapedRecipe(atv, new ItemStack(itemWrench), new Object[] {
        	"X", "X", "X", 'X', Item.ingotIron
        });
		if(!hasPlanesMod)
			SdkTools.setShapedRecipe(atv, new ItemStack(itemAtvWheel), new Object[] {
	        	" X ", "XYX", " X ", 'X', Item.leather, 'Y', Item.ingotIron
	        });
	}
	
	@Override
	public void HandlePacket(Packet200ModLoader packet200ModLoader, EntityPlayerMP entityPlayerMp)
	{
		switch(packet200ModLoader.packetType)
		{
			case 0:
			{
				if(packet200ModLoader.dataInt[0] == 0)
				{
					isSniperZoomedin.put(entityPlayerMp, false);
				}
				else if(packet200ModLoader.dataInt[0] == 1)
				{
					isSniperZoomedin.put(entityPlayerMp, true);
				}
			}
		}
	}
	
	@Override
	public void HandleSendKey(EntityPlayerMP entityPlayerMp, int keyCode)
	{
		switch (keyCode)
		{
		case 0:
			if(entityPlayerMp.ridingEntity instanceof SdkEntityAtv)
			{
				if(entityPlayerMp.currentCraftingInventory instanceof SdkCraftingInventoryAtvCB)
					entityPlayerMp.usePersonalCraftingInventory();
				else
					ModLoader.OpenGUI(entityPlayerMp, 14, (SdkEntityAtv)entityPlayerMp.ridingEntity,
							new SdkCraftingInventoryAtvCB(entityPlayerMp.inventory, (SdkEntityAtv)entityPlayerMp.ridingEntity));
			}
			break;
		case 1:
			if(entityPlayerMp.ridingEntity instanceof SdkEntityAtv)
				((SdkEntityAtv)entityPlayerMp.ridingEntity).fireGuns();
			break;
		}
	}

	private void handleReload() {
		Iterator<Map.Entry<EntityPlayer,Integer>> it = reloadTimes.entrySet().iterator();
    	while (it.hasNext()) {
    	    Map.Entry<EntityPlayer,Integer> entry = it.next();
    	    
    	    int n = entry.getValue() - 1;
    	    
    	    if (n <= 0)
    	        it.remove();
    	    else
    	    	entry.setValue(n);
    	}
	}

	private void handleFlash() {
		Iterator<Map.Entry<EntityLiving,Pair<Integer, Float>>> it = flashTimes.entrySet().iterator();
    	while (it.hasNext())
    	{
    	    Map.Entry<EntityLiving,Pair<Integer, Float>> entry = it.next();
    	    
    	    int n = entry.getValue().getLeft() - 1;
    	    
    	    if (n <= 0)
    	    {
    	    	entry.getKey().moveSpeed = entry.getValue().getRight();
    	        it.remove();
    	    }
    	    else
    	    {
    	    	entry.setValue(new Pair<Integer, Float>(n, entry.getValue().getRight()));
    	    }
    	}
	}

	public static void handleReload(World world, EntityPlayer entityPlayer, boolean forcedReload)
	{
		if(!reloadTimes.containsKey(entityPlayer))
		{
			ItemStack itemStack = entityPlayer.getCurrentEquippedItem();
			if(itemStack != null && itemStack.getItem() instanceof SdkItemGun)
			{
				Item ammo = ((SdkItemGun)itemStack.getItem()).requiredBullet;
	
				int firstIndex = -1;
				int firstAmmoAmount = -1, secondAmmoAmount = -1;
				boolean hasReloaded = false;
				do
				{
					secondAmmoAmount = -1;
					
					InventoryPlayer inventory = entityPlayer.inventory;
					for(int j = firstIndex + 1; j < inventory.mainInventory.length; j++)
			            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == ammo.shiftedIndex)
			            {
			            	if(ammo.getMaxDamage() > 0)
			            	{
			            		int fullAmmoCount = ammo.getMaxDamage() + 1;
			            		
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = fullAmmoCount - inventory.mainInventory[j].getItemDamage();
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.getMaxDamage() > 0 && firstAmmoAmount == ammo.getMaxDamage() + 1)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = fullAmmoCount - inventory.mainInventory[j].getItemDamage();
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(fullAmmoCount - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			setItemDamage(inventory.mainInventory[firstIndex], fullAmmoCount - firstAmmoAmount);
			            			setItemDamage(inventory.mainInventory[j], fullAmmoCount - secondAmmoAmount);
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = new ItemStack(Item.bucketEmpty);
		            				
		            				break;
			            		}
			            	}
			            	else
			            	{
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = inventory.mainInventory[j].stackSize;
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.getMaxDamage() == 0 && firstAmmoAmount == ammo.maxStackSize)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = inventory.mainInventory[j].stackSize;
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(ammo.maxStackSize - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			inventory.mainInventory[firstIndex].stackSize = firstAmmoAmount;
		            				inventory.mainInventory[j].stackSize = secondAmmoAmount;
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = null;
		            				
		            				break;
			            		}
			            	}
			            	
			            	if(firstIndex == -1)
			            		firstIndex = j;
			            }
					
					// Break if no ammo found
					if(firstIndex == -1)
						break;
					
					// Reload and break if forced
					if(!hasReloaded && forcedReload)
					{
						reload(world, entityPlayer);
						break;
					}
					
					// Break if only one ammo stack found
					if(secondAmmoAmount == -1)
						break;
					
					// Break if full
					if(ammo.getMaxDamage() == 0 && firstAmmoAmount == ammo.maxStackSize)
						break;
					
					// Break if full
					if(ammo.getMaxDamage() > 0 && firstAmmoAmount == ammo.getMaxDamage() + 1)
						break;
				}
				while(true);
			}
		}
	}
	
	public static void reload(World world, EntityPlayer entityplayer)
	{
		world.playSoundAtEntity(entityplayer, "sdk.reload", 1.0F, 1.0F / (entityplayer.rand.nextFloat() * 0.1F + 0.95F));
		reloadTimes.put(entityplayer, 40);
	}

	public static boolean getSniperZoomedIn(EntityPlayer entityPlayer)
	{
		Boolean isSniperZoomedInBoolean = isSniperZoomedin.get(entityPlayer);
		
		return isSniperZoomedInBoolean == null ? false : isSniperZoomedInBoolean;
	}

	public void sendProperties(EntityPlayerMP entityPlayerMp)
	{
		int[] dataInt = new int[14];
		dataInt[0] = guns ? 1 : 0;
		dataInt[1] = bulletsDestroyGlass ? 1 : 0;
		dataInt[2] = grenades ? 1 : 0;
		dataInt[3] = explosionsDestroyBlocks ? 1 : 0;
		dataInt[4] = nuke ? 1 : 0;
		dataInt[5] = nukeFuse;
		dataInt[6] = oil ? 1 : 0;
		dataInt[7] = lighter ? 1 : 0;
		dataInt[8] = cannon ? 1 : 0;
		dataInt[9] = sentries ? 1 : 0;
		dataInt[10] = sentriesKillAnimals ? 1 : 0;
		dataInt[11] = atv ? 1 : 0;
		dataInt[12] = ammoRestrictions ? 1 : 0;
		dataInt[13] = hardcore ? 1 : 0;
		
		float[] dataFloat = new float[1];
		dataFloat[0] = nukeBlastDiameter;
		
		Packet200ModLoader packet200ModLoader = new Packet200ModLoader();
		packet200ModLoader.packetType = 1;
		packet200ModLoader.dataInt = dataInt;
		packet200ModLoader.dataFloat = dataFloat;
		ModLoaderMp.SendPacketTo(this, entityPlayerMp, packet200ModLoader);
	}
	
	public static void setItemDamage(ItemStack itemStack, int itemDamage)
	{
		try
		{
			ModLoader.setPrivateValue(ItemStack.class, itemStack, 3, itemDamage);
		}
		catch (NoSuchFieldException ex)
		{
			ModLoader.getLogger().throwing("mod_SdkGuns", "setItemDamage", ex);
			SdkTools.ThrowException("SDK, you forgot to update your obfuscated reflection!", ex);
			return;
		}
	}
	
	public static boolean playerInventoryEmpty(InventoryPlayer inventory)
    {
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null)
            {
            	return false;
            }
        }
        
        for(int j = 0; j < inventory.armorInventory.length; j++)
        {
            if(inventory.armorInventory[j] != null)
            {
            	return false;
            }
        }
        
        return true;
    }

	@Override
	public void OnMainMenu() { }
}
